<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `src/main.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>main.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css"><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script src="../../storage.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="shortcut icon" href="../../favicon.ico"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../geoip_maxmind/index.html'><div class='logo-container'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../settings.html"><img src="../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">env</span>;

<span class="kw">mod</span> <span class="ident">lib</span>;
<span class="kw">use</span> <span class="ident">lib</span>::<span class="ident">arg_parser</span>;
<span class="kw">use</span> <span class="ident">lib</span>::<span class="ident">input_file_reader</span>;
<span class="kw">use</span> <span class="ident">lib</span>::<span class="ident">maxmind_reader</span>;
<span class="kw">use</span> <span class="ident">lib</span>::<span class="ident">output_formatter</span>;
<span class="kw">use</span> <span class="ident">lib</span>::<span class="ident">thread_function</span>;
<span class="kw">use</span> <span class="ident">lib</span>::<span class="ident">func_help</span>;


<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">io</span>::<span class="ident">prelude</span>::<span class="kw-2">*</span>;

<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">time</span>::<span class="ident">Instant</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">sync</span>::{<span class="ident">mpsc</span>,<span class="ident">Arc</span>};





<span class="kw">fn</span> <span class="ident">main</span>() {


    <span class="comment">// bench time ...</span>
    <span class="kw">let</span> <span class="ident">start</span> <span class="op">=</span> <span class="ident">Instant</span>::<span class="ident">now</span>();

    <span class="kw">let</span> <span class="ident">args</span> : <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">env</span>::<span class="ident">args</span>().<span class="ident">collect</span>();

    <span class="comment">// getting cmd line arg</span>
    <span class="kw">let</span> <span class="ident">my_args</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">arg_parser</span>::<span class="ident">arg_parser</span>(<span class="kw-2">&amp;</span><span class="ident">args</span>){
        <span class="prelude-val">Ok</span>(<span class="ident">a</span>) <span class="op">=</span><span class="op">&gt;</span> {
           <span class="ident">a</span>
        },
        <span class="prelude-val">Err</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> {
            <span class="ident">func_help</span>::<span class="ident">print_error</span>(<span class="kw-2">&amp;</span><span class="ident">e</span>);
            <span class="kw">return</span>;
        }
    };

    <span class="comment">// getting buffer from input file</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">my_buffer_input</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">input_file_reader</span>::<span class="ident">input_file_reader</span>(<span class="kw-2">&amp;</span><span class="ident">my_args</span>.<span class="ident">input_file</span>) {
        <span class="prelude-val">Ok</span>(<span class="ident">a</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">a</span>,
        <span class="prelude-val">Err</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> {
            <span class="ident">func_help</span>::<span class="ident">print_error</span>(<span class="kw-2">&amp;</span><span class="ident">e</span>);
            <span class="kw">return</span>;      
        }

    };


    <span class="comment">// getting file for output</span>
    <span class="kw">let</span> <span class="ident">out_file</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">output_formatter</span>::<span class="ident">open_file_for_output</span>(<span class="kw-2">&amp;</span><span class="ident">my_args</span>.<span class="ident">output_file</span>){
        <span class="prelude-val">Ok</span>(<span class="ident">a</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">a</span>,
        <span class="prelude-val">Err</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> {
            <span class="ident">func_help</span>::<span class="ident">print_error</span>(<span class="kw-2">&amp;</span><span class="ident">e</span>);
            <span class="kw">return</span>;
        }
    };



    <span class="kw">let</span> <span class="ident">db_data</span> : <span class="ident">Arc</span><span class="op">&lt;</span><span class="ident">maxmind_reader</span>::<span class="ident">ReaderDb</span><span class="op">&gt;</span>;
    <span class="comment">// getting database</span>
    <span class="kw">match</span> <span class="ident">maxmind_reader</span>::<span class="ident">reader_db</span>(<span class="kw-2">&amp;</span><span class="ident">my_args</span>.<span class="ident">database_folder</span>) {
        <span class="prelude-val">Ok</span>(<span class="ident">o</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">db_data</span> <span class="op">=</span> <span class="ident">Arc</span>::<span class="ident">new</span>(<span class="ident">o</span>),
        <span class="prelude-val">Err</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> {
            <span class="ident">func_help</span>::<span class="ident">print_error</span>(<span class="kw-2">&amp;</span><span class="ident">e</span>);
            <span class="kw">return</span>;
        }
    }


    <span class="comment">// content line </span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">contents</span> <span class="op">=</span> <span class="ident">String</span>::<span class="ident">new</span>();
    
    <span class="comment">// channel for output </span>
    <span class="kw">let</span> (<span class="ident">writer_tx</span>, <span class="ident">writer_rx</span>) <span class="op">=</span> <span class="ident">mpsc</span>::<span class="ident">channel</span>();
    
    <span class="comment">// channel for database access reader... </span>
    <span class="kw">let</span> (<span class="ident">db_tx</span>, <span class="ident">db_rx</span>) <span class="op">=</span> <span class="ident">mpsc</span>::<span class="ident">channel</span>();
  

    
    <span class="comment">// thread one reader activation done </span>
    <span class="kw">let</span> <span class="ident">db_jh</span> <span class="op">=</span> <span class="ident">thread_function</span>::<span class="ident">get_db_thread</span>(<span class="ident">Arc</span>::<span class="ident">clone</span>(<span class="kw-2">&amp;</span><span class="ident">db_data</span>),<span class="ident">db_rx</span>,<span class="ident">writer_tx</span>.<span class="ident">clone</span>(),<span class="ident">my_args</span>.<span class="ident">memo_limit</span>);
    

    <span class="comment">// loop to get line by line the data in input file </span>
    <span class="comment">// two case unordered we can create 2 threads for the reader process </span>
    <span class="comment">// ordered one thread for the reader process is needed</span>

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">line_id</span> <span class="op">=</span> <span class="number">0</span>;
    
    <span class="kw">if</span> <span class="ident">my_args</span>.<span class="ident">unordered</span> <span class="op">=</span><span class="op">=</span> <span class="number">1</span> {
        
        <span class="comment">//  thread output </span>
        <span class="kw">let</span> <span class="ident">writer_jh</span> <span class="op">=</span> <span class="ident">thread_function</span>::<span class="ident">get_writer_thread</span>(<span class="ident">out_file</span>,<span class="ident">writer_rx</span>,<span class="number">2</span>);
        
        <span class="comment">// 2nd channel for multi thread</span>
        <span class="kw">let</span> (<span class="ident">db2_tx</span> , <span class="ident">db2_rx</span>) <span class="op">=</span> <span class="ident">mpsc</span>::<span class="ident">channel</span>();
        <span class="comment">// thread two reader</span>
        <span class="kw">let</span> <span class="ident">db2_jh</span> <span class="op">=</span> <span class="ident">thread_function</span>::<span class="ident">get_db_thread</span>(<span class="ident">Arc</span>::<span class="ident">clone</span>(<span class="kw-2">&amp;</span><span class="ident">db_data</span>),<span class="ident">db2_rx</span>,<span class="ident">writer_tx</span>,<span class="ident">my_args</span>.<span class="ident">memo_limit</span>);
        
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">alternate</span> <span class="op">=</span> <span class="number">0</span>;    
    
        <span class="kw">loop</span> {
            <span class="comment">// get a line</span>
            <span class="ident">contents</span>.<span class="ident">clear</span>();
            <span class="ident">line_id</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
            <span class="kw">match</span> <span class="ident">my_buffer_input</span>.<span class="ident">read_line</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">contents</span>) {
                <span class="prelude-val">Ok</span>(<span class="number">0</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="ident">db_tx</span>.<span class="ident">send</span>(<span class="ident">String</span>::<span class="ident">from</span>(<span class="string">&quot;SHUTDOWN&quot;</span>)).<span class="ident">unwrap</span>();
                    <span class="ident">db2_tx</span>.<span class="ident">send</span>(<span class="ident">String</span>::<span class="ident">from</span>(<span class="string">&quot;SHUTDOWN&quot;</span>)).<span class="ident">unwrap</span>();
                    <span class="kw">break</span>;
                 }
                <span class="prelude-val">Ok</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> {},
                <span class="prelude-val">Err</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="ident">func_help</span>::<span class="ident">print_error</span>(<span class="string">&quot;Can t read from buffer ...&quot;</span>);
                }
            }
                    
            <span class="comment">// removing \n </span>
            <span class="ident">contents</span>.<span class="ident">remove</span>(<span class="ident">contents</span>.<span class="ident">len</span>()<span class="op">-</span><span class="number">1</span>);
            
            <span class="kw">if</span> <span class="ident">contents</span> <span class="op">=</span><span class="op">=</span> <span class="string">&quot;SHUTDOWN&quot;</span> {
                <span class="ident">contents</span>.<span class="ident">push</span>(<span class="string">&#39;.&#39;</span>);
            }
            <span class="comment">// sending a clone </span>
            <span class="kw">if</span> <span class="ident">alternate</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> {
                <span class="ident">db_tx</span>.<span class="ident">send</span>(<span class="ident">line_id</span>.<span class="ident">to_string</span>() <span class="op">+</span> <span class="string">&quot; &quot;</span> <span class="op">+</span> <span class="ident">contents</span>.<span class="ident">as_str</span>()).<span class="ident">unwrap</span>();
                <span class="ident">alternate</span> <span class="op">=</span> <span class="number">1</span>;
            }
            <span class="kw">else</span>{
                <span class="ident">db2_tx</span>.<span class="ident">send</span>(<span class="ident">line_id</span>.<span class="ident">to_string</span>()<span class="op">+</span> <span class="string">&quot; &quot;</span> <span class="op">+</span> <span class="ident">contents</span>.<span class="ident">as_str</span>()).<span class="ident">unwrap</span>();
                <span class="ident">alternate</span><span class="op">=</span> <span class="number">0</span>;
            }
    
        }
    
        
    
    
        <span class="comment">// wait until all is finished </span>
        <span class="ident">writer_jh</span>.<span class="ident">join</span>().<span class="ident">unwrap</span>();    
        <span class="ident">db_jh</span>.<span class="ident">join</span>().<span class="ident">unwrap</span>();
        <span class="ident">db2_jh</span>.<span class="ident">join</span>().<span class="ident">unwrap</span>();

    }
    <span class="kw">else</span>{
        <span class="comment">// ordered mode work with only 3 threads</span>
        <span class="comment">//  thread output </span>
        <span class="kw">let</span> <span class="ident">writer_jh</span> <span class="op">=</span> <span class="ident">thread_function</span>::<span class="ident">get_writer_thread</span>(<span class="ident">out_file</span>,<span class="ident">writer_rx</span>,<span class="number">1</span>);
        
            <span class="kw">loop</span> {
            <span class="comment">// get a line</span>
            <span class="ident">contents</span>.<span class="ident">clear</span>();
            <span class="ident">line_id</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
            <span class="kw">match</span> <span class="ident">my_buffer_input</span>.<span class="ident">read_line</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">contents</span>) {
                <span class="prelude-val">Ok</span>(<span class="number">0</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="ident">db_tx</span>.<span class="ident">send</span>(<span class="ident">String</span>::<span class="ident">from</span>(<span class="string">&quot;SHUTDOWN&quot;</span>)).<span class="ident">unwrap</span>();
                    <span class="kw">break</span>;
                 }
                <span class="prelude-val">Ok</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> {},
                <span class="prelude-val">Err</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="ident">func_help</span>::<span class="ident">print_error</span>(<span class="string">&quot;Can t read from buffer ...&quot;</span>);
                }
            }
                    
            <span class="comment">// removing \n </span>
            <span class="ident">contents</span>.<span class="ident">remove</span>(<span class="ident">contents</span>.<span class="ident">len</span>()<span class="op">-</span><span class="number">1</span>);
            
            <span class="kw">if</span> <span class="ident">contents</span> <span class="op">=</span><span class="op">=</span> <span class="string">&quot;SHUTDOWN&quot;</span> {
                <span class="ident">contents</span>.<span class="ident">push</span>(<span class="string">&#39;.&#39;</span>);
            }
            <span class="comment">// sending a clone </span>
            <span class="ident">db_tx</span>.<span class="ident">send</span>(<span class="ident">line_id</span>.<span class="ident">to_string</span>() <span class="op">+</span> <span class="string">&quot; &quot;</span> <span class="op">+</span> <span class="ident">contents</span>.<span class="ident">as_str</span>()).<span class="ident">unwrap</span>();
    
        }
        
        
        <span class="comment">// wait until all is finished </span>
        <span class="ident">writer_jh</span>.<span class="ident">join</span>().<span class="ident">unwrap</span>();    
        <span class="ident">db_jh</span>.<span class="ident">join</span>().<span class="ident">unwrap</span>();
        
    }
    

    <span class="comment">// bench end </span>
    <span class="kw">let</span> <span class="ident">elapsed</span> <span class="op">=</span> <span class="ident">start</span>.<span class="ident">elapsed</span>();
    <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;Done : {:?}&quot;</span>,<span class="ident">elapsed</span>);
    
}

</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../";window.currentCrate = "geoip_maxmind";</script><script src="../../aliases.js"></script><script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script><script defer src="../../search-index.js"></script></body></html>